## netradiant 1.5.0%2Bgit20250728%2Bdfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9 FATAL_ERROR)

project(NetRadiant C CXX)

#-----------------------------------------------------------------------
# Builtins: configuration
#-----------------------------------------------------------------------

set(BUILTINS_INSTALL_DIR "${CMAKE_BINARY_DIR}/builtins")
set(BUILTINS_INCLUDE_DIR "${BUILTINS_INSTALL_DIR}/include")
set(BUILTINS_LIB_DIR "${BUILTINS_INSTALL_DIR}/lib")
set(BUILTINS_PKGCONFIG_DIR "${BUILTINS_INSTALL_DIR}/lib/pkgconfig")

option(BUILTIN_GTKGLEXT "Builtin GtkGLExt" OFF)
option(BUILTIN_GTKTHEME_MOJAVE "Builtin Mojave GTK theme" OFF)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

if (APPLE)
    set(BUILTIN_GTKGLEXT ON)
    set(BUILTIN_GTKTHEME_MOJAVE ON)
endif ()

set(BUILTIN_GTKGLEXT_BUILT OFF CACHE INTERNAL "...")
if (EXISTS "${BUILTINS_PKGCONFIG_DIR}/gtkglext-1.0.pc")
    set(BUILTIN_GTKGLEXT_BUILT ON)
endif ()

if (EXISTS "${BUILTINS_INCLUDE_DIR}")
    include_directories("${BUILTINS_INCLUDE_DIR}")
endif ()

if (EXISTS "${BUILTINS_LIB_DIR}")
    set(ENV{LD_LIBRARY_PATH} "$ENV{LD_LIBRARY_PATH}:${BUILTINS_LIB_DIR}")
    link_directories("${BUILTINS_LIB_DIR}")
endif ()

if (EXISTS "${BUILTINS_PKGCONFIG_DIR}")
    set(ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:${BUILTINS_PKGCONFIG_DIR}")
endif ()

#-----------------------------------------------------------------------
# CMake modules
#-----------------------------------------------------------------------

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

#-----------------------------------------------------------------------
# Submodules
#-----------------------------------------------------------------------

if (EXISTS "${PROJECT_SOURCE_DIR}/libs/crunch/inc/crn_decomp.h")
    set(DEFAULT_BUILD_CRUNCH ON CACHE INTERNAL "...")
else ()
    set(DEFAULT_BUILD_CRUNCH OFF CACHE INTERNAL "...")
endif ()

#-----------------------------------------------------------------------
# Build options
#-----------------------------------------------------------------------

option(BUILD_RADIANT "Build the GUI" ON)
option(BUILD_TOOLS "Build the tools" ON)
option(BUILD_CRUNCH "Build Crunch image support" ${DEFAULT_BUILD_CRUNCH})
option(DOWNLOAD_GAMEPACKS "Download game packs" ON)
# option(USE_WERROR "Build with -Werror -pedantic-errors" OFF)
option(USE_WERROR "Build with -Werror" OFF)
option(FHS_INSTALL "Install according to Filesystem Hierarchy Standard" OFF)
option(FHS_INSTALL_ABSOLUTE "Install using absolute paths (requires FHS_INSTALL)" OFF)

set(BUILD_BINARIES OFF CACHE INTERNAL "...")
if (BUILD_RADIANT OR BUILD_TOOLS)
    set(BUILD_BINARIES ON)
endif ()

if (BUILD_BINARIES)
    if (WIN32
        OR APPLE
        OR "${CMAKE_SYSTEM_NAME}" STREQUAL "Linux"
        OR "${CMAKE_SYSTEM_NAME}" STREQUAL "FreeBSD" )
        set(BUNDLING_SUPPORTED ON)
    endif()

    if (BUNDLING_SUPPORTED)
        if(WIN32 AND NOT CMAKE_CROSSCOMPILING)
            set(BUNDLE_LIBRARIES_DEFAULT ON)
        else ()
            set(BUNDLE_LIBRARIES_DEFAULT OFF)
        endif ()

        option(BUNDLE_LIBRARIES "Bundle libraries" ${BUNDLE_LIBRARIES_DEFAULT})
    endif ()

    if (BUNDLE_LIBRARIES AND BUNDLING_SUPPORTED)
        set(FHS_INSTALL OFF CACHE PATH "Disabled because of BUNDLE_LIBRARIES is enabled" FORCE)
    endif ()

    if (NOT FHS_INSTALL AND FHS_INSTALL_ABSOLUTE)
        set(FHS_INSTALL_ABSOLUTE OFF CACHE PATH "Disabled because of FHS_INSTALL is disabled" FORCE)
    endif ()
endif ()

#-----------------------------------------------------------------------
# Paths
#-----------------------------------------------------------------------

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "${PROJECT_SOURCE_DIR}/install" CACHE PATH "..." FORCE)
endif ()

if (APPLE)
    set(APPLE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}/NetRadiant.app)
    set(FINAL_INSTALL_PREFIX ${APPLE_INSTALL_PREFIX}/Contents/Prefix)
else ()
    set(FINAL_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
endif ()

set(RADIANT_NAME "NetRadiant" CACHE INTERNAL "...")
add_definitions(-DRADIANT_NAME="${RADIANT_NAME}")
set(RADIANT_BASENAME "netradiant" CACHE INTERNAL "...")
add_definitions(-DRADIANT_BASENAME="${RADIANT_BASENAME}")

set(RADIANT_BIN_DIR ${FINAL_INSTALL_PREFIX} CACHE INTERNAL "...")
set(RADIANT_LIB_DIR ${FINAL_INSTALL_PREFIX}/lib CACHE INTERNAL "...")
set(RADIANT_ADDONS_DIR ${FINAL_INSTALL_PREFIX} CACHE INTERNAL "...")
set(RADIANT_SHARE_DIR ${FINAL_INSTALL_PREFIX}/share CACHE INTERNAL "...")
set(RADIANT_DATA_DIR ${FINAL_INSTALL_PREFIX} CACHE INTERNAL "...")

if (FHS_INSTALL)
    add_definitions(-DRADIANT_FHS_INSTALL='ON')

    set(RADIANT_BIN_DIR ${FINAL_INSTALL_PREFIX}/bin)
    set(RADIANT_LIB_DIR ${FINAL_INSTALL_PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE})
    set(RADIANT_ADDONS_DIR ${RADIANT_LIB_DIR}/${RADIANT_BASENAME})
    set(RADIANT_SHARE_DIR ${FINAL_INSTALL_PREFIX}/share)
    set(RADIANT_DATA_DIR ${RADIANT_SHARE_DIR}/${RADIANT_BASENAME})
    set(RADIANT_LIB_DIR ${FINAL_INSTALL_PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE})

    if (FHS_INSTALL_ABSOLUTE)
        add_definitions(-DRADIANT_ADDONS_DIR="${RADIANT_ADDONS_DIR}")
        add_definitions(-DRADIANT_DATA_DIR="${RADIANT_DATA_DIR}")
    else ()
        add_definitions(-DRADIANT_LIB_ARCH="${CMAKE_LIBRARY_ARCHITECTURE}")
    endif ()
endif ()


set(GAMEPACKS_DOWNLOAD_DIR ${PROJECT_BINARY_DIR}/download CACHE PATH "Where to store downloaded game packs")

#-----------------------------------------------------------------------
# Version
#-----------------------------------------------------------------------

# CMake 3.0+ would allow this in project()
set(RADIANT_VERSION_MAJOR 1)
set(RADIANT_VERSION_MINOR 5)
set(RADIANT_VERSION_PATCH 0)
set(RADIANT_VERSION "${RADIANT_VERSION_MAJOR}.${RADIANT_VERSION_MINOR}.${RADIANT_VERSION_PATCH}")

set(RADIANT_ABOUTMSG "Custom build" CACHE STRING "About message")

set(RADIANT_VERSION_STRING "${RADIANT_VERSION}n")

if (NOT DEFINED GIT_VERSION)
     find_package(Git REQUIRED)

     execute_process(
          COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
          WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
          OUTPUT_VARIABLE GIT_VERSION
          OUTPUT_STRIP_TRAILING_WHITESPACE
     )

     if (GIT_VERSION)
         set(RADIANT_VERSION_STRING "${RADIANT_VERSION_STRING}-git-${GIT_VERSION}")
     endif ()
endif ()

message(STATUS "Building ${PROJECT_NAME} ${RADIANT_VERSION_STRING} ${RADIANT_ABOUTMSG}")

#-----------------------------------------------------------------------
# Language standard
#-----------------------------------------------------------------------

if (BUILD_BINARIES)
    set(CMAKE_CXX_STANDARD 11)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
    set(CMAKE_CXX_EXTENSIONS OFF)

    if (CMAKE_VERSION VERSION_LESS "3.1")
        if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR CMAKE_COMPILER_IS_GNUCXX)
            include(CheckCXXCompilerFlag)
            check_cxx_compiler_flag(--std=c++${CMAKE_CXX_STANDARD} STD_CXX)
            if (STD_CXX)
                set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++${CMAKE_CXX_STANDARD}")
            else ()
                message(SEND_ERROR "Requires C++${CMAKE_CXX_STANDARD} or better")
            endif ()
        else ()
            message(WARNING "Unrecognized compiler: ${CMAKE_CXX_COMPILER_ID}, make sure it supports C++${CMAKE_CXX_STANDARD}")
        endif ()
    endif ()
endif ()

#-----------------------------------------------------------------------
# Flags
#-----------------------------------------------------------------------

if (BUILD_BINARIES)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions -fno-rtti")

    macro (addflags_c args)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${args}")
    endmacro ()

    macro (addflags_cxx args)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${args}")
    endmacro ()

    macro (addflags args)
        addflags_c("${args}")
        addflags_cxx("${args}")
    endmacro ()

    addflags("-fno-strict-aliasing")
    if (NOT WIN32)
        addflags("-fvisibility=hidden")
    endif ()

    if (USE_WERROR)
        addflags("-Werror")
        # addflags("-pedantic-errors")
    endif ()

    addflags("-Wall")
    addflags("-Wextra")
    # addflags("-pedantic")

    addflags_c("-Wno-deprecated-declarations") # vfs.c: g_strdown

    addflags("-Wno-unused-function")
    addflags("-Wno-unused-variable")
    addflags("-Wno-unused-parameter")

    if (APPLE)
        add_definitions(-DGL_SILENCE_DEPRECATION=1)
    endif()

    set(CMAKE_POSITION_INDEPENDENT_CODE 1)
endif ()

if (BUILD_RADIANT)
    set(GTK_TARGET 2 CACHE STRING "GTK target")
    add_definitions(-DGTK_TARGET=${GTK_TARGET})

    if (WIN32)
        add_definitions(-DWORKAROUND_WINDOWS_FLOATING_WINDOW=1)

        if (GTK_TARGET EQUAL 2)
            add_definitions(-DWORKAROUND_WINDOWS_GTK2_GLWIDGET=1)
        endif ()
    elseif (APPLE)
        if (GTK_TARGET EQUAL 2)
            add_definitions(-DWORKAROUND_MACOS_GTK2_DESTROY=1)
            add_definitions(-DWORKAROUND_MACOS_GTK2_GLWIDGET=1)
            add_definitions(-DWORKAROUND_MACOS_GTK2_LAGGYPOINTER=1)
        endif ()
    endif()

    # Should be set here because the define is used in libs/
    set(RADIANT_IQM_PLUGIN_HELP "IQM Plugin used by NetRadiant (iqmmodel, picomodel)")
    set(RADIANT_IQM_PLUGIN "" CACHE STRING "${RADIANT_IQM_PLUGIN_HELP}")
    if("${RADIANT_IQM_PLUGIN}" STREQUAL "iqmmodel")
    elseif("${RADIANT_IQM_PLUGIN}" STREQUAL "picomodel")
    else()
        if(APPLE)
            # The picomodel iqm library is buggy on recent macOS
            set(RADIANT_IQM_PLUGIN "iqmmodel" CACHE STRING "${RADIANT_IQM_PLUGIN_HELP}" FORCE)
        else()
            set(RADIANT_IQM_PLUGIN "picomodel" CACHE STRING "${RADIANT_IQM_PLUGIN_HELP}" FORCE)
        endif()
    endif()
    add_definitions(-DRADIANT_IQM_PLUGIN_${RADIANT_IQM_PLUGIN}=1)
    add_definitions(-DRADIANT_IQM_PLUGIN="${RADIANT_IQM_PLUGIN}")
endif ()

#-----------------------------------------------------------------------
# Defs
#-----------------------------------------------------------------------

if (BUILD_BINARIES)
    add_definitions(-DRADIANT_VERSION="${RADIANT_VERSION}")
    add_definitions(-DRADIANT_VERSION_STRING="${RADIANT_VERSION_STRING}")

    if (NOT CMAKE_BUILD_TYPE MATCHES Release)
        add_definitions(-D_DEBUG=1)
    endif ()
endif ()

if (BUILD_RADIANT)
    add_definitions(-DRADIANT_ABOUTMSG="${RADIANT_ABOUTMSG}")

    macro (disable_deprecated name gtk2only)
        add_definitions(-D${name}_DISABLE_SINGLE_INCLUDES)
        if ((${gtk2only} EQUAL 0) OR (GTK_TARGET EQUAL 2))
            add_definitions(-D${name}_DISABLE_DEPRECATED)
        endif ()
    endmacro ()

    disable_deprecated(ATK 0)
    disable_deprecated(G 0)
    disable_deprecated(GDK 0)
    disable_deprecated(GDK_PIXBUF 0)
    disable_deprecated(GTK 1)
    disable_deprecated(PANGO 0)
endif ()

if (BUILD_BINARIES)
    add_custom_target(binaries ALL)

    if(APPLE OR ${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
        link_directories(
            /usr/local/lib
        )
    endif ()

    if (WIN32)
        add_definitions(
            -DWIN32=1
            -D_WIN32=1
        )
    else ()
        add_definitions(
            -DPOSIX=1
        )
    endif ()
endif ()

if (BUILD_RADIANT AND NOT APPLE AND NOT WIN32)
    set(XWINDOWS ON)
    find_package(X11 REQUIRED)
    include_directories(${X11_INCLUDE_DIR})
    add_definitions(-DXWINDOWS=1)
endif ()

if (BUILD_BINARIES)
    include_directories("${PROJECT_SOURCE_DIR}/include")
    include_directories("${PROJECT_SOURCE_DIR}/libs")

    macro (copy_dlls target)
        if (BUNDLE_LIBRARIES AND BUNDLING_SUPPORTED)
            add_custom_command(TARGET ${target} POST_BUILD
                COMMAND "${PROJECT_SOURCE_DIR}/library-bundler"
                "register" "${PROJECT_BINARY_DIR}" "$<TARGET_FILE:${target}>"
                VERBATIM
            )
            add_dependencies(bundle ${target})
        endif ()
    endmacro ()
endif ()

=== libs/signal/CMakeLists.txt ===
add_library(signal STATIC
        isignal.h
        signal.cpp signal.h
        signalfwd.h
        )

=== debian/changelog ===
netradiant (1.5.0+git20250728+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #693637)
    Only provides the q3map2 tool for now.

 -- Sébastien Noel <sebastien@twolife.be>  Tue, 28 Oct 2025 10:19:41 +0100

## netradiant 1.5.0%2Bgit20250729%2Bdfsg

=== contrib/sunplug/CMakeLists.txt ===
radiant_plugin(sunplug
        sunplug.cpp sunplug.h
        )

target_include_directories(sunplug PRIVATE uilib)
target_link_libraries(sunplug PRIVATE uilib)

## netradiant 1.5.0+git20250728+dfsg

=== Makefile ===
# TODO: when deleting this Makefile, don't forget to also delete conftest.cpp
# which is only required by this Makefile

ifeq ($(I_KNOW_MAKEFILE_IS_DEPRECATED),)
    $(shell printf 'ERROR: Makefile build is deprecated, use CMake instead, see README.md\n\n' >&2)
    $(error I_KNOW_MAKEFILE_IS_DEPRECATED is not set)
else
    $(shell printf 'WARNING: deprecated Makefile build enforced\n\n' >&2)
endif

MAKEFILE_CONF      ?= Makefile.conf
-include $(MAKEFILE_CONF)

## CONFIGURATION SETTINGS
# user customizable stuf
# you may override this in Makefile.conf or the environment
BUILD              ?= debug
# or: release, or: debug, or: extradebug, or: profile, or: native
OS                 ?= $(shell uname)
# or: Linux, Win32, Darwin
LDFLAGS            ?=
CFLAGS             ?=
CXXFLAGS           ?=
CPPFLAGS           ?=
LIBS               ?=
RADIANT_ABOUTMSG   ?= Custom build
RADIANT_NAME       ?= NetRadiant
RADIANT_BASENAME   ?= netradiant

# warning: this directory may NOT contain any files other than the ones written by this Makefile!
# NEVER SET THIS TO A SYSTEM WIDE "bin" DIRECTORY!
INSTALLDIR         ?= install
DOWNLOADDIR        ?= build/download

CC                 ?= gcc
CXX                ?= g++
RANLIB             ?= ranlib
AR                 ?= ar
LDD                ?= ldd # nothing on Win32
OTOOL              ?= # only used on OS X
WINDRES            ?= windres # only used on Win32

PKGCONFIG          ?= pkg-config
PKG_CONFIG_PATH    ?=

SH                 ?= $(SHELL)
ECHO               ?= echo
ECHO_NOLF          ?= echo -n
CAT                ?= cat
MKDIR              ?= mkdir -p
CP                 ?= cp
CP_R               ?= $(CP) -r --preserve=timestamps
LN                 ?= ln
LN_SNF             ?= $(LN) -snf
RM                 ?= rm
RM_R               ?= $(RM) -r
TEE_STDERR         ?= | tee /dev/stderr
TR                 ?= tr
FIND               ?= find
DIFF               ?= diff
SED                ?= sed
GIT                ?= git
SVN                ?= svn
WGET               ?= wget
MV                 ?= mv
UNZIPPER           ?= unzip

FD_TO_DEVNULL      ?= >/dev/null
STDOUT_TO_DEVNULL  ?= 1$(FD_TO_DEVNULL)
STDERR_TO_DEVNULL  ?= 2$(FD_TO_DEVNULL)
STDERR_TO_STDOUT   ?= 2>&1
TO_DEVNULL         ?= $(STDOUT_TO_DEVNULL) $(STDERR_TO_STDOUT)

CPPFLAGS_GLIB      ?= $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) glib-2.0 --cflags $(STDERR_TO_DEVNULL))
LIBS_GLIB          ?= $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) glib-2.0 --libs-only-L $(STDERR_TO_DEVNULL)) \
                      $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) glib-2.0 --libs-only-l $(STDERR_TO_DEVNULL))
CPPFLAGS_XML       ?= $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) libxml-2.0 --cflags $(STDERR_TO_DEVNULL))
LIBS_XML           ?= $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) libxml-2.0 --libs-only-L $(STDERR_TO_DEVNULL)) \
                      $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) libxml-2.0 --libs-only-l $(STDERR_TO_DEVNULL))
CPPFLAGS_PNG       ?= $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) libpng --cflags $(STDERR_TO_DEVNULL))
LIBS_PNG           ?= $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) libpng --libs-only-L $(STDERR_TO_DEVNULL)) \
                      $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) libpng --libs-only-l $(STDERR_TO_DEVNULL))
CPPFLAGS_WEBP      ?= $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) libwebp --cflags $(STDERR_TO_DEVNULL))
LIBS_WEBP          ?= $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) libwebp --libs-only-L $(STDERR_TO_DEVNULL)) \
                      $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) libwebp --libs-only-l $(STDERR_TO_DEVNULL))
CPPFLAGS_GTK       ?= $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) gtk+-2.0 --cflags $(STDERR_TO_DEVNULL))
LIBS_GTK           ?= $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) gtk+-2.0 --libs-only-L $(STDERR_TO_DEVNULL)) \
                      $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) gtk+-2.0 --libs-only-l $(STDERR_TO_DEVNULL))
CPPFLAGS_PANGOFT2  ?= $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) pangoft2 --cflags $(STDERR_TO_DEVNULL))
LIBS_PANGOFT2      ?= $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) pangoft2 --libs-only-L $(STDERR_TO_DEVNULL)) \
                      $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) pangoft2 --libs-only-l $(STDERR_TO_DEVNULL))
CPPFLAGS_GTKGLEXT  ?= $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) gtkglext-1.0 --cflags $(STDERR_TO_DEVNULL))
LIBS_GTKGLEXT      ?= $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) gtkglext-1.0 --libs-only-L $(STDERR_TO_DEVNULL)) \
                      $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) gtkglext-1.0 --libs-only-l $(STDERR_TO_DEVNULL))
CPPFLAGS_GL        ?=
LIBS_GL            ?= -lGL # -lopengl32 on Win32
CPPFLAGS_DL        ?=
LIBS_DL            ?= -ldl # nothing on Win32
CPPFLAGS_ZLIB      ?=
LIBS_ZLIB          ?= -lz -lminizip
CPPFLAGS_JPEG      ?=
LIBS_JPEG          ?= -ljpeg
DEPEND_ON_MAKEFILE ?= yes
DOWNLOAD_GAMEPACKS ?= yes
# set to no to disable gamepack, set to all to even download undistributable gamepacks

# Support CHECK_DEPENDENCIES with DOWNLOAD_GAMEPACKS semantics
ifneq ($(CHECK_DEPENDENCIES),)
DEPENDENCIES_CHECK = $(patsubst yes,quiet,$(patsubst no,off,$(CHECK_DEPENDENCIES)))
else
DEPENDENCIES_CHECK ?= quiet
# or: off, verbose
endif

# these are used on Win32 only
GTKDIR             ?= $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKGCONFIG) gtk+-2.0 --variable=prefix $(STDERR_TO_DEVNULL))
WHICHDLL           ?= which
DLLINSTALL         ?= install-dlls.sh

# alias mingw32 OSes
ifeq ($(OS),MINGW32_NT-6.0)
	OS = Win32
endif
ifeq ($(OS),Windows_NT)
	OS = Win32
endif

CFLAGS_COMMON = -MMD -W -Wall -Wcast-align -Wcast-qual -Wno-unused-parameter -fno-strict-aliasing
CPPFLAGS_COMMON =
LDFLAGS_COMMON =
LIBS_COMMON =
CXXFLAGS_COMMON = -std=c++11 -Wno-non-virtual-dtor -Wreorder -fno-exceptions -fno-rtti

ifeq ($(BUILD),debug)
ifeq ($(findstring $(CFLAGS),-g),)
	CFLAGS_COMMON += -g
	# only add -g if no -g flag is in $(CFLAGS)
endif
ifeq ($(findstring $(CFLAGS),-O),)
	CFLAGS_COMMON += -O
	# only add -O if no -O flag is in $(CFLAGS)
endif
	CPPFLAGS_COMMON +=
	LDFLAGS_COMMON +=
else

ifeq ($(BUILD),extradebug)
ifeq ($(findstring $(CFLAGS),-g),)
	CFLAGS_COMMON += -g3
	# only add -g3 if no -g flag is in $(CFLAGS)
endif
	CPPFLAGS_COMMON += -D_DEBUG
	LDFLAGS_COMMON +=
else

ifeq ($(BUILD),profile)
ifeq ($(findstring $(CFLAGS),-g),)
	CFLAGS_COMMON += -g
	# only add -g if no -g flag is in $(CFLAGS)
endif
ifeq ($(findstring $(CFLAGS),-O),)
	CFLAGS_COMMON += -O
	# only add -O if no -O flag is in $(CFLAGS)
endif
	CFLAGS_COMMON += -pg
	CPPFLAGS_COMMON +=
	LDFLAGS_COMMON += -pg
else

ifeq ($(BUILD),release)
ifeq ($(findstring $(CFLAGS),-O),)
	CFLAGS_COMMON += -O3
	# only add -O3 if no -O flag is in $(CFLAGS)
endif
	CPPFLAGS_COMMON +=
	LDFLAGS_COMMON += -s
else

ifeq ($(BUILD),native)
ifeq ($(findstring $(CFLAGS),-O),)
	CFLAGS_COMMON += -O3
	# only add -O3 if no -O flag is in $(CFLAGS)
endif
	CFLAGS_COMMON += -march=native -mtune=native
	CPPFLAGS_COMMON +=
	LDFLAGS_COMMON += -s
else

$(error Unsupported build type: $(BUILD))
endif
endif
endif
endif
endif

INSTALLDIR_BASE := $(INSTALLDIR)

MAKE_EXE_SYMLINK = false

ifeq ($(OS),Linux)
	CPPFLAGS_COMMON += -DPOSIX -DXWINDOWS
	CFLAGS_COMMON += -fPIC
	LDFLAGS_DLL = -fPIC -ldl
	LIBS_COMMON = -lpthread
	EXE ?= $(shell uname -m)
	MAKE_EXE_SYMLINK = true
	A = a
	DLL = so
	MWINDOWS =
else

ifeq ($(OS),Win32)
	CPPFLAGS_COMMON += -DWIN32 -D_WIN32 -D_inline=inline -DWORKAROUND_WINDOWS_FLOATING_WINDOW=1 -DWORKAROUND_WINDOWS_GTK2_GLWIDGET=1
	CFLAGS_COMMON += -mms-bitfields
	LDFLAGS_DLL = -Wl,--add-stdcall-alias
	LIBS_COMMON = -lws2_32 -luser32 -lgdi32 -lole32
	EXE ?= exe
	A = a
	DLL = dll
	MWINDOWS = -mwindows

	# workaround: we have no "ldd" for Win32, so...
	LDD =
	# workaround: OpenGL library for Win32 is called opengl32.dll
	LIBS_GL = -lopengl32
	# workaround: no -ldl on Win32
	LIBS_DL = 
else

ifeq ($(OS),Darwin)
	CPPFLAGS_COMMON += -DPOSIX -DXWINDOWS
	CFLAGS_COMMON += -fPIC
	CXXFLAGS_COMMON += -fno-exceptions -fno-rtti
	MACLIBDIR ?= /opt/local/lib
	CPPFLAGS_COMMON += -I$(MACLIBDIR)/../include -I/usr/X11R6/include
	LDFLAGS_COMMON += -L$(MACLIBDIR) -L/usr/X11R6/lib
	LDFLAGS_DLL += -dynamiclib -ldl
	EXE ?= $(shell uname -m)
	MAKE_EXE_SYMLINK = true
	A = a
	DLL = dylib
	MWINDOWS =
	# workaround for weird prints
	ECHO_NOLF = /bin/echo -n

	# workaround: http://developer.apple.com/qa/qa2007/qa1567.html
	LIBS_GL += -lX11 -dylib_file /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib:/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib
	LIBS_GTKGLEXT += -lX11 -dylib_file /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib:/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib
	# workaround: we have no "ldd" for OS X, so...
	LDD =
	OTOOL = otool
else

$(error Unsupported build OS: $(OS))
endif
endif
endif

# VERSION!
RADIANT_MAJOR_VERSION = 1
RADIANT_MINOR_VERSION = 5
RADIANT_PATCH_VERSION = 0
RADIANT_VERSION_NUMBER = $(RADIANT_MAJOR_VERSION).$(RADIANT_MINOR_VERSION).$(RADIANT_PATCH_VERSION)
RADIANT_VERSION = $(RADIANT_VERSION_NUMBER)n
Q3MAP_VERSION = 2.5.17n

GIT_VERSION := $(shell $(GIT) rev-parse --short HEAD $(STDERR_TO_DEVNULL))
ifneq ($(GIT_VERSION),)
	RADIANT_VERSION := $(RADIANT_VERSION)-git-$(GIT_VERSION)
	Q3MAP_VERSION := $(Q3MAP_VERSION)-git-$(GIT_VERSION)
endif

CPPFLAGS += -DRADIANT_VERSION="\"$(RADIANT_VERSION)\"" -DRADIANT_VERSION_STRING="\"$(RADIANT_VERSION_STRING)\"" -DRADIANT_ABOUTMSG="\"$(RADIANT_ABOUTMSG)\"" -DRADIANT_NAME="\"${RADIANT_NAME}\"" -DRADIANT_BASENAME="\"${RADIANT_BASENAME}\"" -DQ3MAP_VERSION="\"$(Q3MAP_VERSION)\""
CPPFLAGS += -DGTK_TARGET=2

.PHONY: all
all: \
	dependencies-check \
	binaries \
	install-data \
	install-dll \

.PHONY: dependencies-check
ifeq ($(findstring $(DEPENDENCIES_CHECK),off),off)
dependencies-check:
	@$(ECHO) dependencies checking disabled, good luck...
else
dependencies-check:
	@$(ECHO)
	@if [ x"$(DEPENDENCIES_CHECK)" = x"verbose" ]; then set -x; exec 3>&2; else exec 3$(FD_TO_DEVNULL); fi; \
	failed=0; \
	checkbinary() \
	{ \
		$(ECHO_NOLF) "Checking for $$2 ($$1)... "; \
		$$2 --help >&3 $(STDERR_TO_STDOUT); \
		if [ $$? != 127 ]; then \
			$(ECHO) "found."; \
		else \
			$(ECHO) "not found, please install it or set PATH right!"; \
			$(ECHO) "To see the failed commands, set DEPENDENCIES_CHECK=verbose"; \
			$(ECHO) "To proceed anyway, set DEPENDENCIES_CHECK=off"; \
			failed=1; \
		fi; \
	}; \
	$(ECHO) checking that the build tools exist; \
	checkbinary "bash (or another shell)" "$(SH)"; \
	checkbinary coreutils "$(ECHO)"; \
	checkbinary coreutils "$(ECHO_NOLF)"; \
	checkbinary coreutils "$(CAT)"; \
	checkbinary coreutils "$(MKDIR)"; \
	checkbinary coreutils "$(CP)"; \
	checkbinary coreutils "$(CP_R)"; \
	checkbinary coreutils "$(RM)"; \
	checkbinary coreutils "$(RM_R)"; \
	checkbinary coreutils "$(MV)"; \
	checkbinary coreutils "$(ECHO) test $(TEE_STDERR)"; \
	checkbinary sed "$(SED)"; \
	checkbinary findutils "$(FIND)"; \
	checkbinary diff "$(DIFF)"; \
	checkbinary gcc "$(CC)"; \
	checkbinary g++ "$(CXX)"; \
	checkbinary binutils "$(RANLIB)"; \
	checkbinary binutils "$(AR)"; \
	checkbinary pkg-config "$(PKGCONFIG)"; \
	checkbinary unzip "$(UNZIPPER)"; \
	checkbinary git-core "$(GIT)"; \
	checkbinary subversion "$(SVN)"; \
	checkbinary wget "$(WGET)"; \
	[ "$(OS)" = "Win32" ] && checkbinary mingw32 "$(WINDRES)"; \
	[ -n "$(LDD)" ] && checkbinary libc6 "$(LDD)"; \
	[ -n "$(OTOOL)" ] && checkbinary xcode "$(OTOOL)"; \
	[ "$$failed" = "0" ] && $(ECHO) All required tools have been found!
	@$(ECHO)
	@if [ x"$(DEPENDENCIES_CHECK)" = x"verbose" ]; then set -x; exec 3>&2; else exec 3$(FD_TO_DEVNULL); fi; \
	failed=0; \
	checkheader() \
	{ \

=== contrib/CMakeLists.txt ===
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/plugins")

add_custom_target(plugins)
macro(radiant_plugin name)
    message(STATUS "Found Plugin ${name}")
    add_library(${name} MODULE ${ARGN})
    add_dependencies(plugins ${name})
    copy_dlls(${name})
    install(
            TARGETS ${name}
            LIBRARY DESTINATION ${RADIANT_ADDONS_DIR}/plugins
    )
endmacro()

add_subdirectory(bobtoolz)
add_subdirectory(brushexport)
add_subdirectory(prtview)
add_subdirectory(shaderplug)
add_subdirectory(sunplug)
add_subdirectory(ufoaiplug)

=== include/CMakeLists.txt ===
add_library(includes
        aboutmsg.h
        cullable.h
        dpkdeps.h
        editable.h
        iarchive.h
        ibrush.h
        icamera.h
        idatastream.h
        ieclass.h
        ientity.h
        ifilesystem.h
        ifiletypes.h
        ifilter.h
        igl.h
        iglrender.h
        iimage.h
        imap.h
        imodel.h
        ipatch.h
        iplugin.h
        ireference.h
        irender.h
        iscenegraph.h
        iscriplib.h
        iselection.h
        ishaders.h
        itexdef.h
        itextstream.h
        itextures.h
        itoolbar.h
        iundo.h
        mapfile.h
        modelskin.h
        moduleobserver.h
        modulesystem.h
        nameable.h
        namespace.h
        preferencesystem.cpp preferencesystem.h
        qerplugin.h
        renderable.h
        selectable.h
        stream_version.h
        warnings.h
        windowobserver.h
        )

=== plugins/CMakeLists.txt ===
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/modules")

add_custom_target(modules)
macro(radiant_plugin name)
    message(STATUS "Found Module ${name}")
    add_library(${name} MODULE ${ARGN})
    add_dependencies(modules ${name})
    copy_dlls(${name})
    install(
            TARGETS ${name}
            LIBRARY DESTINATION ${RADIANT_ADDONS_DIR}/modules
    )
endmacro()

add_subdirectory(archivepak)
add_subdirectory(archivewad)
add_subdirectory(archivezip)
add_subdirectory(entity)
add_subdirectory(image)

if(BUILD_CRUNCH)
	add_subdirectory(imagecrn)
endif()

add_subdirectory(imagehl)
add_subdirectory(imagepng)
add_subdirectory(imageq2)
add_subdirectory(imagewebp)

if("${RADIANT_IQM_PLUGIN}" STREQUAL "iqmmodel")
    add_subdirectory(iqmmodel)
endif()

add_subdirectory(mapq3)
add_subdirectory(mapxml)
add_subdirectory(md3model)

# picomodel: md3, obj, ase, (optional) iqm
add_subdirectory(model)

add_subdirectory(shaders)
add_subdirectory(vfspk3)

=== radiant/CMakeLists.txt ===
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}")

find_package(OpenGL REQUIRED)
find_package(GTK${GTK_TARGET} REQUIRED)

string(SUBSTRING ${CMAKE_SHARED_MODULE_SUFFIX} 1 -1 _clibext)
add_definitions(-DCMAKE_SHARED_MODULE_SUFFIX="${_clibext}")
unset(_clibext)

set(RADIANTLIST
    autosave.cpp autosave.h
    brush.cpp brush.h
    brush_primit.cpp brush_primit.h
    brushmanip.cpp brushmanip.h
    brushmodule.cpp brushmodule.h
    brushnode.cpp brushnode.h
    brushtokens.cpp brushtokens.h
    brushxml.cpp brushxml.h
    build.cpp build.h
    camwindow.cpp camwindow.h
    clippertool.cpp clippertool.h
    commands.cpp commands.h
    console.cpp console.h
    csg.cpp csg.h
    dialog.cpp dialog.h
    eclass.cpp eclass.h
    eclass_def.cpp eclass_def.h
    eclass_doom3.cpp eclass_doom3.h
    eclass_fgd.cpp eclass_fgd.h
    eclass_xml.cpp eclass_xml.h
    entity.cpp entity.h
    entityinspector.cpp entityinspector.h
    entitylist.cpp entitylist.h
    environment.cpp environment.h
    error.cpp error.h
    feedback.cpp feedback.h
    filetypes.cpp filetypes.h
    filterbar.cpp filterbar.h
    filters.cpp filters.h
    findtexturedialog.cpp findtexturedialog.h
    grid.cpp grid.h
    groupdialog.cpp groupdialog.h
    gtkdlgs.cpp gtkdlgs.h
    gtkmisc.cpp gtkmisc.h
	gtktheme.cpp gtktheme.h
    help.cpp help.h
    image.cpp image.h
    main.cpp main.h
    mainframe.cpp mainframe.h
    map.cpp map.h
    mru.cpp mru.h
    nullmodel.cpp nullmodel.h
    parse.cpp parse.h
    patch.cpp patch.h
    patchdialog.cpp patchdialog.h
    patchmanip.cpp patchmanip.h
    patchmodule.cpp patchmodule.h
    plugin.cpp plugin.h
    pluginapi.cpp pluginapi.h
    pluginmanager.cpp pluginmanager.h
    pluginmenu.cpp pluginmenu.h
    plugintoolbar.cpp plugintoolbar.h
    points.cpp points.h
    preferencedictionary.cpp preferencedictionary.h
    preferences.cpp preferences.h
    qe3.cpp qe3.h
    qgl.cpp qgl.h
    referencecache.cpp referencecache.h
    renderer.cpp renderer.h
    renderstate.cpp renderstate.h
    resource.h
    scenegraph.cpp scenegraph.h
    select.cpp select.h
    selection.cpp selection.h
    server.cpp server.h
    shaders.cpp shaders.h
    sockets.cpp sockets.h
    stacktrace.cpp stacktrace.h
    surfacedialog.cpp surfacedialog.h
    texmanip.cpp texmanip.h
    textureentry.cpp textureentry.h
    textures.cpp textures.h
    texwindow.cpp texwindow.h
    timer.cpp timer.h
    treemodel.cpp treemodel.h
    undo.cpp undo.h
    url.cpp url.h
    view.cpp view.h
    watchbsp.cpp watchbsp.h
    winding.cpp winding.h
    windowobservers.cpp windowobservers.h
    xmlstuff.cpp xmlstuff.h
    xywindow.cpp xywindow.h
)

if (WIN32)
    list(APPEND RADIANTLIST multimon.cpp multimon.h)
endif ()

radiant_tool(${RADIANT_BASENAME} WIN32 radiant.rc ${RADIANTLIST})
add_dependencies(${RADIANT_BASENAME} modules)
target_link_libraries(${RADIANT_BASENAME}
    ${CMAKE_DL_LIBS}
    ${LIBXML2_LIBRARIES}
    ${OPENGL_gl_LIBRARY}
    ${GTK${GTK_TARGET}_LIBRARIES}
    ${GTKGL_LIBRARIES}
    includes
    cmdlib
    container
    ddslib
    debugging
    etclib
    filematch
    generic
    l_net
    math
    mathlib
    memory
    modulesystem
    os
    picomodel
    profile
    script
    signal
    splines
    stream
    string
    transformpath
    uilib
    xmllib
)

if (X11_LIBRARIES)
    target_link_libraries(${RADIANT_BASENAME} ${X11_LIBRARIES})
endif ()

# PIE executables were wrongly recognized as shared libraries on Linux
# because of a mistake in the mime-type library.
# Because of that it was not possible to launch such executables from
# the file browser.
#
# While the problem is fixed upstream, most distributions still ship
# with a faulty mime-type library and may do for a long time.
#
# See: https://gitlab.freedesktop.org/xdg/shared-mime-info/-/issues/11
#
# It may produce such warning though at strip time:
#   warning: allocated section `.dynstr' not in segment
# and produce an unusable binary, better not strip when using this hack.
#
# This hack is only wanted for release build and
# when NetRadiant is not installed system-wide.
if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Linux"
    AND "${CMAKE_BUILD_TYPE}" STREQUAL "Release"
    AND NOT FHS_INSTALL)
    target_link_libraries(${RADIANT_BASENAME} -no-pie)
endif()

if(NOT WIN32 AND NOT APPLE)
    if(GTK_TARGET EQUAL 3)
        if(OpenGL_GL_PREFERENCE STREQUAL "GLVND")
            # This should not be needed, as FindOpenGL should take care of
            # this, but maybe GTK rewrites this badly?

            # If not -lOpenGL:
            #   /usr/bin/ld: CMakeFiles/netradiant.dir/qgl.cpp.o: in function `QGL_sharedContextCreated(OpenGLBinding&)':
            #   qgl.cpp:(.text+0x1c52): undefined reference to `glAccum'

            # If not -lGL:
            #   /usr/bin/ld: CMakeFiles/netradiant.dir/qgl.cpp.o: in function `QGL_Shutdown(OpenGLBinding&)':
            #   qgl.cpp:(.text+0x2d): undefined reference to `glXQueryExtension'

            target_link_libraries(${RADIANT_BASENAME} -lOpenGL -lGL)
        endif()
    endif()
endif()

copy_dlls(${RADIANT_BASENAME})

=== tools/CMakeLists.txt ===
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}")

add_subdirectory(quake2)
add_subdirectory(heretic2)
add_subdirectory(quake3)

add_custom_target(tools)
add_dependencies(tools quake2 heretic2 quake3)

=== contrib/bobtoolz/CMakeLists.txt ===
radiant_plugin(bobtoolz
        dialogs/dialogs-gtk.cpp dialogs/dialogs-gtk.h

        bobToolz.h
        bobToolz-GTK.cpp bobToolz-GTK.h
        bsploader.cpp bsploader.h
        cportals.cpp CPortals.h
        ctfresource_gtk.h
        DBobView.cpp DBobView.h
        DBrush.cpp DBrush.h
        DEntity.cpp DEntity.h
        DEPair.cpp DEPair.h
        DMap.cpp DMap.h
        DPatch.cpp DPatch.h
        DPlane.cpp DPlane.h
        DPoint.cpp DPoint.h
        DShape.cpp DShape.h
        DTrainDrawer.cpp DTrainDrawer.h
        DTreePlanter.cpp DTreePlanter.h
        DVisDrawer.cpp DVisDrawer.h
        DWinding.cpp DWinding.h
        funchandlers-GTK.cpp
        lists.cpp lists.h
        misc.cpp misc.h
        resource.h
        resource-gtk.h
        ScriptParser.cpp ScriptParser.h
        shapes.cpp shapes.h
        visfind.cpp visfind.h
        )

target_include_directories(bobtoolz PRIVATE uilib)
target_link_libraries(bobtoolz PRIVATE uilib)

target_include_directories(bobtoolz PRIVATE mathlib)
target_link_libraries(bobtoolz PRIVATE mathlib)

=== contrib/brushexport/CMakeLists.txt ===
radiant_plugin(brushexport
        callbacks.cpp callbacks.h
        export.cpp export.h
        interface.cpp
        plugin.cpp plugin.h
        support.cpp support.h
        )

target_include_directories(brushexport PRIVATE uilib)
target_link_libraries(brushexport PRIVATE uilib)

=== contrib/prtview/CMakeLists.txt ===
radiant_plugin(prtview
        ConfigDialog.cpp ConfigDialog.h
        LoadPortalFileDialog.cpp LoadPortalFileDialog.h
        portals.cpp portals.h
        prtview.cpp prtview.h
        )

target_include_directories(prtview PRIVATE uilib)
target_link_libraries(prtview PRIVATE uilib)

target_include_directories(prtview PRIVATE profile)
target_link_libraries(prtview PRIVATE profile)

=== contrib/shaderplug/CMakeLists.txt ===
radiant_plugin(shaderplug
        shaderplug.cpp shaderplug.h
        )

target_include_directories(shaderplug PRIVATE uilib)
target_link_libraries(shaderplug PRIVATE uilib)

target_include_directories(shaderplug PRIVATE xmllib)
target_link_libraries(shaderplug PRIVATE xmllib)

=== contrib/ufoaiplug/CMakeLists.txt ===
radiant_plugin(ufoaiplug
        ufoai.cpp ufoai.h
        ufoai_filters.cpp ufoai_filters.h
        ufoai_gtk.cpp ufoai_gtk.h
        ufoai_level.cpp ufoai_level.h
        )

target_include_directories(ufoaiplug PRIVATE uilib)
target_link_libraries(ufoaiplug PRIVATE uilib)

=== libs/cmdlib/CMakeLists.txt ===
add_library(cmdlib STATIC
        cmdlib.cpp ../cmdlib.h
        )

=== debian/control ===
Source: netradiant
Section: graphics
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sébastien Noel <sebastien@twolife.be>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libgl-dev,
               libglib2.0-dev,
#               libgtk-3-dev,
               libjpeg-dev,
               libminizip-dev,
               libpng-dev,
               libwebp-dev,
               libxml2-dev,
               libz-dev,
               pkgconf
Standards-Version: 4.7.2
Homepage: https://netradiant.gitlab.io/
Vcs-Browser: https://salsa.debian.org/twolife/netradiant
Vcs-Git: https://salsa.debian.org/twolife/netradiant.git

#Package: netradiant
#Architecture: any
#Depends: ${misc:Depends}, ${shlibs:Depends}, netradiant-q3map2
#Description: Level design toolchain for 3D FPS games
# NetRadiant is a 3D map and level editor for games based on the idtech
# engines. The software is based on GtkRadiant and focuses on the games
# Doom3, Heretic2, Quake (1, 2, 3 & 4) & Xonotic

Package: netradiant-q3map2
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Quake 3 map compiler
 q3map2 is a compiler for maps to be used with quake 3 compatible engines,
 such as the Darkplaces engine (as used by Xonotic) and many others.
 .
 This version is shipped with the netradiant level editor and is
 developed by the Xonotic team.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
GIT_VERSION := $(shell echo ${DEB_VERSION_UPSTREAM} | sed 's/^[0-9\.]*+git//' )

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_RADIANT=OFF -DDOWNLOAD_GAMEPACKS=OFF -DFHS_INSTALL=ON -DGIT_VERSION=${GIT_VERSION}
	#-DGTK_TARGET=3

override_dh_auto_install:
	mkdir -p debian/netradiant-q3map2/usr/bin/
	install -m 755 obj-*/q3map2 debian/netradiant-q3map2/usr/bin/netradiant-q3map2

=== debian/watch ===
version=4

opts="mode=git,pgpmode=none,pretty=1.5.0+git%cd,repacksuffix=+dfsg,dversionmangle=s/\+dfsg$//,compression=xz" \
https://gitlab.com/xonotic/netradiant.git HEAD

#opts="component=gamepack-darkplaces, \
#      mode=svn, \
#      pretty=%cd.%h, \
#      repack, \
#      compression=xz, \
#      dversionmangle=auto" \
#svn://svn.icculus.org/gtkradiant-gamepacks/DarkPlacesPack/branches/1.5/ HEAD ignore
#
#opts="component=gamepack-doom3, \
#      mode=svn, \
#      pretty=%cd.%h, \
#      repack, \
#      compression=xz, \
#      dversionmangle=auto" \
#svn://svn.icculus.org/gtkradiant-gamepacks/Doom3Pack/branches/1.5/ HEAD ignore
#
#opts="component=gamepack-heretic2, \
#      mode=svn, \
#      pretty=%cd.%h, \
#      repack, \
#      compression=xz, \
#      dversionmangle=auto" \
#svn://svn.icculus.org/gtkradiant-gamepacks/Her2Pack/branches/1.5/ HEAD ignore
#
#opts="component=gamepack-quake1, \
#      pretty=%cd.%h, \
#      repack, \
#      compression=xz, \
#      dversionmangle=auto" \
#http://ingar.intranifty.net/files/netradiant/gamepacks/ Quake1Pack.zip ignore
#
#opts="component=gamepack-quake2, \
#      mode=svn, \
#      pretty=%cd.%h, \
#      repack, \
#      compression=xz, \
#      dversionmangle=auto" \
#svn://svn.icculus.org/gtkradiant-gamepacks/Q2Pack/branches/1.5/ HEAD ignore
#
#opts="component=gamepack-quake3, \
#      mode=git, \
#      pgpmode=none, \
#      pretty=%cd.%h, \
#      repack, \
#      compression=xz, \
#      dversionmangle=auto" \
#https://gitlab.com/netradiant/gamepacks/quake3-mapeditor-support.git HEAD ignore
#
#opts="component=gamepack-quake4, \
#      mode=svn, \
#      pretty=%cd.%h, \
#      repack, \
#      compression=xz, \
#      dversionmangle=auto" \
#svn://svn.icculus.org/gtkradiant-gamepacks/Q4Pack/branches/1.5/ HEAD ignore
#
#opts="component=gamepack-xonotic, \
#      mode=git, \
#      pgpmode=none, \
#      pretty=%cd.%h, \
#      repack, \
#      compression=xz, \
#      dversionmangle=auto" \
#https://gitlab.com/xonotic/netradiant-xonoticpack.git HEAD ignore

## netradiant 1.5.0+git20250729+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -146,6 +146,7 @@
     endif ()
 endif ()
 
+set(RADIANT_MAN_DIR ${RADIANT_SHARE_DIR}/man)
 
 set(GAMEPACKS_DOWNLOAD_DIR ${PROJECT_BINARY_DIR}/download CACHE PATH "Where to store downloaded game packs")
 
@@ -357,7 +358,3 @@
                 VERBATIM
             )
             add_dependencies(bundle ${target})
-        endif ()
-    endmacro ()
-endif ()
-

=== bundle/CMakeLists.txt ===
if (WIN32)
    set(BUNDLE_OS_NAME "windows")
    set(BUNDLE_SHARE ON)
elseif (APPLE)
    set(BUNDLE_OS_NAME "macos")
    set(BUNDLE_SHARE ON)
    set(BUNDLE_ETC ON)
elseif ("${CMAKE_SYSTEM_NAME}" STREQUAL "Linux")
    set(BUNDLE_OS_NAME "linux")
elseif ("${CMAKE_SYSTEM_NAME}" STREQUAL "FreeBSD")
    set(BUNDLE_OS_NAME "freebsd")
else ()
    set(BUNDLE_OS_NAME "unsupported")
endif ()

add_custom_target(bundle ALL
    COMMAND
    export LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH} &&
    "${PROJECT_SOURCE_DIR}/library-bundler"
    "${BUNDLE_OS_NAME}" "${PROJECT_BINARY_DIR}"
    VERBATIM
    COMMENT "Bundling libraries"
)

install(DIRECTORY
    ${PROJECT_BINARY_DIR}/lib
    DESTINATION ${FINAL_INSTALL_PREFIX}
)

if (BUNDLE_SHARE)
    install(DIRECTORY
        ${PROJECT_BINARY_DIR}/share
        DESTINATION ${FINAL_INSTALL_PREFIX}
    )
endif ()

if (BUNDLE_ETC)
    install(DIRECTORY
        ${PROJECT_BINARY_DIR}/etc
        DESTINATION ${FINAL_INSTALL_PREFIX}
    )
endif ()

=== libs/CMakeLists.txt ===
add_subdirectory(cmdlib)
add_subdirectory(container)

if (BUILD_CRUNCH)
    add_subdirectory(crnrgba)
endif ()

add_subdirectory(ddslib)
add_subdirectory(debugging)
add_subdirectory(etclib)
add_subdirectory(filematch)
add_subdirectory(generic)

if (BUILD_RADIANT)
    add_subdirectory(gtkutil)
    add_subdirectory(uilib)
endif ()

add_subdirectory(l_net)
add_subdirectory(math)
add_subdirectory(mathlib)
add_subdirectory(memory)
add_subdirectory(modulesystem)
add_subdirectory(os)
add_subdirectory(picomodel)
add_subdirectory(profile)
add_subdirectory(script)
add_subdirectory(signal)
add_subdirectory(splines)
add_subdirectory(stream)
add_subdirectory(string)
add_subdirectory(transformpath)
add_subdirectory(xml)

add_library(libs
        _.cpp
        archivelib.h
        bytebool.h
        bytestreamutils.h
        character.h
        convert.h
        dragplanes.h
        eclasslib.h
        entitylib.h
        entityxml.h
        fs_filesystem.h
        fs_path.h
        globaldefs.h
        imagelib.h
        property.h
        instancelib.h
        maplib.h
        moduleobservers.h
        pivot.h
        render.h
        scenelib.h
        selectionlib.h
        shaderlib.h
        str.h
        stringio.h
        texturelib.h
        transformlib.h
        traverselib.h
        typesystem.h
        undolib.h
        uniquenames.h
        versionlib.h
        )

find_package(GLIB REQUIRED)
target_include_directories(libs PRIVATE ${GLIB_INCLUDE_DIRS})
target_link_libraries(libs PRIVATE ${GLIB_LIBRARIES})

=== libs/container/CMakeLists.txt ===
add_library(container STATIC
        array.cpp array.h
        cache.h
        container.h
        hashfunc.h
        hashtable.cpp hashtable.h
        stack.h
        )

=== libs/crnrgba/CMakeLists.txt ===
add_library(crnrgba STATIC
        crn_rgba.h
        crn_rgba.cpp
        ../crunch/inc/crn_decomp.h
        ../crunch/inc/crnlib.h
        )

set_target_properties(crnrgba PROPERTIES LINKER_LANGUAGE CXX)
target_link_libraries(crnrgba PRIVATE ddslib)
target_compile_options(crnrgba PRIVATE -fexceptions)

=== libs/filematch/CMakeLists.txt ===
add_library(filematch STATIC
        ../filematch.c ../filematch.h
        )

=== libs/memory/CMakeLists.txt ===
add_library(memory STATIC
        allocator.cpp allocator.h
        )

=== libs/string/CMakeLists.txt ===
add_library(string STATIC
        pooledstring.cpp pooledstring.h
        string.h
        stringfwd.h
        )

=== plugins/entity/CMakeLists.txt ===
radiant_plugin(entity
        angle.h
        angles.h
        colour.h
        curve.h
        doom3group.cpp doom3group.h
        eclassmodel.cpp eclassmodel.h
        entity.cpp entity.h
        filters.cpp filters.h
        generic.cpp generic.h
        group.cpp group.h
        keyobservers.h
        light.cpp light.h
        miscmodel.cpp miscmodel.h
        model.h
        modelskinkey.h
        namedentity.h
        namekeys.h
        origin.h
        plugin.cpp
        rotation.h
        scale.h
        skincache.cpp skincache.h
        targetable.cpp targetable.h
        )

target_include_directories(entity
    PRIVATE $<TARGET_PROPERTY:uilib,INTERFACE_INCLUDE_DIRECTORIES>
)

=== plugins/imagecrn/CMakeLists.txt ===
radiant_plugin(imagecrn
        imagecrn.cpp
        crn.cpp crn.h
        )

target_include_directories(imagecrn PRIVATE ${CMAKE_SOURCE_DIR}/libs/crnrgba)
target_link_libraries(imagecrn PRIVATE crnrgba)

=== plugins/shaders/CMakeLists.txt ===
radiant_plugin(shaders
        plugin.cpp
        shaders.cpp shaders.h
        )

find_package(GLIB REQUIRED)
target_include_directories(shaders PRIVATE ${GLIB_INCLUDE_DIRS})
target_link_libraries(shaders PRIVATE ${GLIB_LIBRARIES})

=== plugins/vfspk3/CMakeLists.txt ===
radiant_plugin(vfspk3
        archive.cpp archive.h
        vfs.cpp vfs.h
        vfspk3.cpp
        )

find_package(GLIB REQUIRED)
target_include_directories(vfspk3 PRIVATE ${GLIB_INCLUDE_DIRS})
target_link_libraries(vfspk3 PRIVATE ${GLIB_LIBRARIES})

target_include_directories(vfspk3 PRIVATE filematch)
target_link_libraries(vfspk3 PRIVATE filematch)

=== debian/changelog ===
netradiant (1.5.0+git20250729+dfsg-1) unstable; urgency=medium

  * New upstream snapshot.
    + drop merged patches & manpages

 -- Sébastien Noel <sebastien@twolife.be>  Mon, 23 Feb 2026 18:00:15 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: netradiant
 Section: graphics
-Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Sébastien Noel <sebastien@twolife.be>
 Build-Depends: debhelper-compat (= 13),
@@ -15,10 +14,10 @@
                libxml2-dev,
                libz-dev,
                pkgconf
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://netradiant.gitlab.io/
-Vcs-Browser: https://salsa.debian.org/twolife/netradiant
-Vcs-Git: https://salsa.debian.org/twolife/netradiant.git
+Vcs-Browser: https://salsa.debian.org/games-team/netradiant
+Vcs-Git: https://salsa.debian.org/games-team/netradiant.git
 
 #Package: netradiant
 #Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -13,5 +13,6 @@
 	#-DGTK_TARGET=3
 
 override_dh_auto_install:
-	mkdir -p debian/netradiant-q3map2/usr/bin/
+	mkdir -p debian/netradiant-q3map2/usr/bin/ debian/netradiant-q3map2/usr/share/man/man1/
 	install -m 755 obj-*/q3map2 debian/netradiant-q3map2/usr/bin/netradiant-q3map2
+	install -m 644 tools/man/q3map2.1 debian/netradiant-q3map2/usr/share/man/man1/netradiant-q3map2.1
